# 
# License-Identifier: GPL
#
# Copyright (C) 2015 The Yambo Team
#
# Authors (see AUTHORS file for details): AF, DS
#
AC_DEFUN([AC_HAVE_IOTK],[
#
AC_ARG_ENABLE(iotk, AS_HELP_STRING([--enable-iotk],[Activate the IOTK support]),[],[enable_iotk="yes"])
AC_ARG_WITH(iotk_libs, AS_HELP_STRING([--with-iotk-libs=<libs>],[Use the IOTK library in <libs>],[32]),[],[])
AC_ARG_WITH(iotk_path, AS_HELP_STRING([--with-iotk-path=<path>],[Path to the IOTK install directory],[32]),[],[])
AC_ARG_WITH(iotk_libdir, AS_HELP_STRING([--with-iotk-libdir=<path>],[Path to the IOTK lib directory],[32]))
AC_ARG_WITH(iotk_includedir, AS_HELP_STRING([--with-iotk-includedir=<path>],[Path to the IOTK include directory],[32]),[],[])

compile_p2y="no"
compile_iotk="no"
internal_iotk="no"
IOTK_LIBS=" "
IOTK_INCS=" "

if test -d "$with_iotk_path"  ;  then enable_iotk=yes ; fi
if test -d "$with_iotk_libdir" ; then enable_iotk=yes ; fi
if test  x"$with_iotk_libs" != "x" ;  then enable_iotk=yes ; fi

if test "x$enable_iotk" = "xyes" ; then
  #
  if test -d "$with_iotk_path" || test -d "$with_iotk_libdir" ; then
    #
    # external IOTK
    #
    if test -d "$with_iotk_path" ;   then AC_MSG_CHECKING([for IOTK in $with_iotk_path]) ; fi
    if test -d "$with_iotk_libdir" ; then AC_MSG_CHECKING([for IOTK in $with_iotk_libdir]) ; fi
    #
    if test -d "$with_iotk_path" ; then
        try_iotk_libdir_src=$with_iotk_path/src
        try_iotk_incdir_src=$with_iotk_path/src
        try_iotk_libdir=$with_iotk_path/lib
        try_iotk_incdir=$with_iotk_path/include
    fi
    if test -d "$with_iotk_libdir"  ;    then try_iotk_libdir=$with_iotk_libdir ; fi
    if test -d "$with_iotk_includedir" ; then try_iotk_incdir=$with_iotk_includedir ; fi
    #
    if test -z "$try_iotk_libdir" ; then AC_MSG_ERROR([No lib-dir specified]) ; fi
    if test -z "$try_iotk_incdir" ; then AC_MSG_ERROR([No include-dir specified]) ; fi
    #
    # 
    if test -r $try_iotk_libdir_src/libiotk.a && test -e $try_iotk_incdir_src/iotk_module.mod ; then
      compile_p2y="yes"
      compile_iotk="no"
      IOTK_INCS="$IFLAG$try_iotk_incdir_src"
      #IOTK_LIBS="$try_iotk_libdir_src/libiotk.a"
      IOTK_LIBS="-L$try_iotk_libdir_src/ -liotk"
      AC_MSG_RESULT([yes])
    elif test -r $try_iotk_libdir/libiotk.a  && test -e $try_iotk_incdir/iotk_module.mod ; then
      compile_p2y="yes"
      compile_iotk="no"
      IOTK_INCS="$IFLAG$try_iotk_incdir"
      #IOTK_LIBS="$try_iotk_libdir/libiotk.a"
      IOTK_LIBS="-L$try_iotk_libdir/ -liotk"
      AC_MSG_RESULT([yes])
    else
      AC_MSG_RESULT([no. Fallback to internal library.])
    fi
  elif test x"$with_iotk_libs" != "x" ; then
    #
    # directly provided lib
    #
    AC_MSG_CHECKING([for IOTK Library using $with_iotk_libs])
    compile_p2y="yes"
    compile_iotk="no"
    if test -d "$with_iotk_includedir" ; then IOTK_INCS="$IFLAG$with_iotk_includedir" ; fi
    IOTK_LIBS="$with_iotk_libs"
    AC_MSG_RESULT(yes)
  fi
  if test "$IOTK_LIBS" = " "; then
    #
    # internal IOTK
    #
    AC_MSG_CHECKING([for internal IOTK library])
    internal_iotk="yes"
    compile_p2y="yes"
    IOTK_INCS="${IFLAG}${extlibs_path}/${FCKIND}/${FC}/include/"
    #IOTK_LIBS="${extlibs_path}/${FCKIND}/${FC}/lib/libiotk.a"
    IOTK_LIBS="-L${extlibs_path}/${FCKIND}/${FC}/lib -liotk"
    if ! test -e "${extlibs_path}/${FCKIND}/${FC}/lib/libiotk.a" || ! test -e "${extlibs_path}/${FCKIND}/${FC}/include/iotk_base.mod" || ! test -e "${extlibs_path}/${FCKIND}/${FC}/include/iotk_specials.h"; then
      compile_iotk="yes"
      if test ! -d lib ; then mkdir lib ; fi
      AC_MSG_RESULT(to be compiled)
      AC_CONFIG_FILES([lib/iotk/make_iotk.inc:lib/iotk/make_iotk.inc.in])
    else
      compile_iotk="no"
      AC_MSG_RESULT(already compiled)
    fi
  fi
  #
  PW_VER="no-hdf5-support"
  PW_CPP=
  #
  #if test x"$hdf5" = "xyes" && test "$IO_LIB_VER" = "parallel"; then
  if test x"$hdf5" = "xyes" && test x"$enable_hdf5_p2y_support" != "xno"; then
    PW_VER="hdf5-support"
    PW_CPP="-D_P2Y_QEXSD_HDF5"
  fi
  #
else
  PW_VER="no support"
  PW_CPP=""
  AC_MSG_CHECKING([for IOTK library])
  AC_MSG_RESULT([no])
fi
#
#
AC_SUBST(PW_VER)
AC_SUBST(PW_CPP)
#
AC_SUBST(compile_p2y)
AC_SUBST(compile_iotk)
AC_SUBST(internal_iotk)
#
AC_SUBST(IOTK_INCS)
AC_SUBST(IOTK_LIBS)
#
])
